package com.benyanyi.okhttp.type;

import com.benyanyi.okhttp.call.RequestConfig;
import com.benyanyi.okhttp.download.DownloadConfig;

import java.util.List;
import java.util.Map;

/**
 * @author YanYi
 * @date 2019-08-12 16:09
 * @email ben@yanyi.red
 * @overview
 */
public interface RequestType {

    RequestConfig getText(Map<String, Object> map);

    RequestConfig postText(Map<String, Object> headerMap, Map<String, Object> bodyMap);

    RequestConfig postFileText(Map<String, Object> bodyMap);

    RequestConfig postFileText(Map<String, Object> headerMap, Map<String, Object> bodyMap);

    RequestConfig postJson(Map<String, Object> map);

    RequestConfig postJson(String string);

    RequestConfig xml(String xml);

    RequestConfig file(Map<String, Object> map);

    RequestConfig file(String... filePaths);

    RequestConfig file(List<String> filePaths);

    DownloadConfig download();

    /**
     * @param isCover 是否覆盖之前的文件
     */
    DownloadConfig download(boolean isCover);

    /**
     * @param suffix 文件名后缀
     */
    DownloadConfig download(String suffix);

    /**
     * @param isCover 是否覆盖之前的文件
     * @param suffix  文件名后缀
     */
    DownloadConfig download(boolean isCover, String suffix);

}
